###################################################
### chunk number 1: preliminaries
###################################################
#line 56 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
library("sets")
options(prompt = "R> ", continue = "+  ", width = 77)


###################################################
### chunk number 2: 
###################################################
#line 145 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
s <- list(1, "1")
union(s, s)
intersect(s, s)


###################################################
### chunk number 3: sets1
###################################################
#line 315 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
s <- set(1L, 2L, 3L)
print(s)


###################################################
### chunk number 4: 
###################################################
#line 322 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
set("test", c, set("a", 2.5), list(1, 2))


###################################################
### chunk number 5: 
###################################################
#line 327 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
set(1, pair(1,2), tuple(1L, 2L, 3L))


###################################################
### chunk number 6: 
###################################################
#line 332 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
s2 <- as.set(2:4)
print(s2)


###################################################
### chunk number 7: setpredicates
###################################################
#line 341 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
set_is_empty(set())
set(1) <= set(1,2)


###################################################
### chunk number 8: 
###################################################
#line 346 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"


###################################################
### chunk number 9: 
###################################################
#line 357 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
length(s)


###################################################
### chunk number 10: 
###################################################
#line 362 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
s | set("a")
s & s2
s %D% s2


###################################################
### chunk number 11: 
###################################################
#line 369 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
s * s2
s ^ 2L


###################################################
### chunk number 12: 
###################################################
#line 374 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
2 ^ s


###################################################
### chunk number 13: 
###################################################
#line 384 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
set_complement(set(1), set(1,2,3))


###################################################
### chunk number 14: >
###################################################
#line 397 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
!set(1)


###################################################
### chunk number 15: <
###################################################
#line 403 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
## subsets
set_combn(s, 2L)


###################################################
### chunk number 16: 
###################################################
#line 410 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
cl <- closure(set(set(1), set(2), set(3)), "union")
print(cl)
reduction(cl, "union")


###################################################
### chunk number 17: setsummary
###################################################
#line 417 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
sum(s)
range(s)


###################################################
### chunk number 18: 
###################################################
#line 425 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
s2 <- set(1,2, c, list(1,2))
print(s2)
s2[[c]] <- "foo"
s2[[list(1, 2)]] <- "bar"
print(s2)
s2[list("foo", 1)]


###################################################
### chunk number 19: iterators
###################################################
#line 436 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
sapply(s, sqrt)
for (i in s) print(i)


###################################################
### chunk number 20: setouter
###################################################
#line 454 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
set_outer(set(1,2), set(1,2,3), "/")


###################################################
### chunk number 21: 
###################################################
#line 498 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
X <- c("A", "B", "C")
gset(support = X)


###################################################
### chunk number 22: 
###################################################
#line 505 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
gset(support = X, universe = LETTERS[1:10])


###################################################
### chunk number 23: 
###################################################
#line 509 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
multi <- 1:3
gset(support = X, memberships = multi)


###################################################
### chunk number 24: 
###################################################
#line 514 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
ms <- c(0.1, 0.3, 1)
gset(support = X, memberships = ms)


###################################################
### chunk number 25: 
###################################################
#line 520 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
gset(elements = list(e("A", 0.1), e("B", 0.2), e("C", 0.3)))


###################################################
### chunk number 26: 
###################################################
#line 525 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
f <- function(x) switch(x, A = 0.1, B = 0.2, C = 1, 0)
gset(universe = X, charfun = f)


###################################################
### chunk number 27: 
###################################################
#line 532 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
ms2 <- list(c(0.1, 0.3, 0.4), c(1, 1),
  gset(support = ms, memberships = multi))
gset(support = X, memberships = ms2)


###################################################
### chunk number 28: 
###################################################
#line 550 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
X <- gset(c("A", "B", "C"), 4:6)
Y <- gset(c("B", "C", "D"), 1:3)

X | Y
X & Y


###################################################
### chunk number 29: 
###################################################
#line 561 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
X + Y
X - Y
gset_product(X, Y)


###################################################
### chunk number 30: 
###################################################
#line 568 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
!gset(1, 0.3)
X <- gset("a", universe = letters[1:3])
!X
!!X
!gset(1L, 2, universe = 1:3, bound = 3)


###################################################
### chunk number 31: 
###################################################
#line 579 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
x <- gset(1:3, 1:3/3)
y <- gset(1:2, 1:2/2)
gset_mean(x, y)
gset_mean(x, y, "harmonic")

gset_mean(set(1), set(1, 2))


###################################################
### chunk number 32: 
###################################################
#line 592 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
x <- gset(1:10, 1:10/10)
gset_transform_memberships(x, pmax, 0.5)


###################################################
### chunk number 33: 
###################################################
#line 599 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
x <- gset(1, 2)
gset_transform_memberships(x, `*`, 0.5)


###################################################
### chunk number 34: 
###################################################
#line 605 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
rep(x, 0.5)


###################################################
### chunk number 35: 
###################################################
#line 614 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
gset_dilate(y)
gset_concentrate(y)
gset_normalize(y, 0.5)


###################################################
### chunk number 36: fuzzy
###################################################
#line 642 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
x <- 1:10 / 10
y <- rev(x)
.S.(x, y)
fuzzy_logic("Fodor")
.S.(x, y)


###################################################
### chunk number 37: 
###################################################
#line 650 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
X <- gset(c("A", "B", "C"), c(0.3, 0.5, 0.8))
print(X)
Y <- gset(c("B", "C", "D"), c(0.1, 0.3, 0.9))
print(Y)


###################################################
### chunk number 38: 
###################################################
#line 657 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
fuzzy_logic("Zadeh")
X & Y
X | Y
gset_complement(X, Y)


###################################################
### chunk number 39: 
###################################################
#line 664 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
fuzzy_logic("Fodor")
X & Y
X | Y
gset_complement(X, Y)


###################################################
### chunk number 40: fuzzyoff
###################################################
#line 670 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
fuzzy_logic("Zadeh")


###################################################
### chunk number 41: 
###################################################
#line 677 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
cut(X, 0.5)


###################################################
### chunk number 42: 
###################################################
#line 700 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
N <- fuzzy_normal(mean = 0, sd = 1)
N(-3:3)

gset(charfun = N, universe = -3:3)


###################################################
### chunk number 43: 
###################################################
#line 709 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
fuzzy_normal_gset(universe = -3:3)


###################################################
### chunk number 44: 
###################################################
#line 716 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
fuzzy_poisson <- charfun_generator(dpois)
gset(charfun = fuzzy_poisson(10), universe = seq(0, 20, 2))


###################################################
### chunk number 45: 
###################################################
#line 726 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
## creating a series of fuzzy normal sets
fuzzy_tuple(fuzzy_normal, 5)


###################################################
### chunk number 46: plot1
###################################################
#line 738 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
## a fuzzy multiset
X <- gset(c("A", "B"), list(1:2/2, 0.5))
plot(X)


###################################################
### chunk number 47: plot2
###################################################
#line 745 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
plot(fuzzy_bell)


###################################################
### chunk number 48: plot3
###################################################
#line 750 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
## creating a sequence of sets
plot(fuzzy_tuple(fuzzy_cone, 10), col = gray.colors(10))


###################################################
### chunk number 49: plot4
###################################################
#line 756 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
x <- fuzzy_normal_gset()
y <- fuzzy_trapezoid_gset(corners = c(5, 10, 15, 17), height = c(0.7, 1))
plot(tuple(x, y), lty = 3)
lines(x | y, col = 2)
lines(gset_mean(x, y), col = 3, lty = 2)


###################################################
### chunk number 50: plot1fig
###################################################
#line 767 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
#line 738 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw#from line#767#"
## a fuzzy multiset
X <- gset(c("A", "B"), list(1:2/2, 0.5))
plot(X)
#line 768 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"


###################################################
### chunk number 51: plot2fig
###################################################
#line 771 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
#line 745 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw#from line#771#"
plot(fuzzy_bell)
#line 772 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"


###################################################
### chunk number 52: plot3fig
###################################################
#line 775 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
#line 750 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw#from line#775#"
## creating a sequence of sets
plot(fuzzy_tuple(fuzzy_cone, 10), col = gray.colors(10))
#line 776 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"


###################################################
### chunk number 53: plot4fig
###################################################
#line 779 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
#line 756 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw#from line#779#"
x <- fuzzy_normal_gset()
y <- fuzzy_trapezoid_gset(corners = c(5, 10, 15, 17), height = c(0.7, 1))
plot(tuple(x, y), lty = 3)
lines(x | y, col = 2)
lines(gset_mean(x, y), col = 3, lty = 2)
#line 780 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"


###################################################
### chunk number 54: 
###################################################
#line 822 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
x <- set("1", 1L, 1, 3.3 - 2.2, 1.1)
print(x)

y <- set(1, 1.1, 2L, "2")
print(y)
1L %e% y

x | y


###################################################
### chunk number 55: 
###################################################
#line 834 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
X <- cset(x, matchfun = match)
print(X)
Y <- cset(y, matchfun = match)
print(Y)
1L %e% Y
X | Y


###################################################
### chunk number 56: 
###################################################
#line 850 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
FUN <- matchfun(function(x, y) isTRUE(all.equal(x, y)))
X <- cset(x, matchfun = FUN)
print(X)
Y <- cset(y, matchfun = FUN)
print(Y)
1L %e% Y

X | Y


###################################################
### chunk number 57: 
###################################################
#line 863 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
sets_options("matchfun", match)
cset(x)
cset(y)

cset(1:3) <= cset(c("1", "2", "3"))


###################################################
### chunk number 58: 
###################################################
#line 870 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
### restore package defaults
sets_options("matchfun", NULL)


###################################################
### chunk number 59: 
###################################################
#line 888 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
cset(letters[1:5], orderfun = 5:1)

FUN <- function(x) order(as.character(x), decreasing = TRUE)
Z <- cset(letters[1:5], orderfun = FUN)
print(Z)
as.character(Z)


###################################################
### chunk number 60: 
###################################################
#line 897 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
o <- ordered(c("a", "b", "a"), levels = c("b", "a"))
as.set(o)
as.gset(o)
as.cset(o)


###################################################
### chunk number 61: 
###################################################
#line 905 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
as.cset(c("A", "quick", "brown", "fox"))
as.cset(c("A", "quick", "brown", "fox", "quick"))


###################################################
### chunk number 62: 
###################################################
#line 923 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
set.seed(4711)
l <- r2dtable(1000, r = 1:2, c = 2:1)


###################################################
### chunk number 63: 
###################################################
#line 932 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
l[1:2]


###################################################
### chunk number 64: 
###################################################
#line 937 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
s <- as.gset(l)
print(s)


###################################################
### chunk number 65: 
###################################################
#line 942 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
for (i in s) s[[i]] <- i[1]
print(s)


###################################################
### chunk number 66: 
###################################################
#line 948 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
gset_memberships(s) / 1000


###################################################
### chunk number 67: 
###################################################
#line 953 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
fisher.test(l[[1]])$p.value


###################################################
### chunk number 68: 
###################################################
#line 969 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
data("fuzzy_docs")
print(fuzzy_docs[8:9])


###################################################
### chunk number 69: 
###################################################
#line 988 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
library("proxy")
d <- dist(fuzzy_docs, gset_dissimilarity)


###################################################
### chunk number 70: 
###################################################
#line 993 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
cl1 <- hclust(d, "ward")


###################################################
### chunk number 71: 
###################################################
#line 999 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
labs1 <- cutree(cl1, 2)
print(labs1)


###################################################
### chunk number 72: clusterplot
###################################################
#line 1007 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
plot(cl1)


###################################################
### chunk number 73: 
###################################################
#line 1022 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
tdm <- set_outer(c("neural networks", "fuzzy", "image"),
  fuzzy_docs, `%in%`)
print(tdm)


###################################################
### chunk number 74: 
###################################################
#line 1028 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
d <- dist(tdm, "Jaccard", by_rows = FALSE)


###################################################
### chunk number 75: 
###################################################
#line 1033 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
cl2 <- hclust(d, "ward")


###################################################
### chunk number 76: 
###################################################
#line 1038 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
labs2 <- cutree(cl2, 2)
print(labs2)
table(labs1, labs2)


###################################################
### chunk number 77: clusterplot2
###################################################
#line 1047 "d:/Rcompile/CRANpkg/local/2.12/sets/inst/doc/sets.Rnw"
plot(cl2)


